/* fork child processes */
/* must be run as root */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

int main(int argc, char **argv)
{
	unsigned int i, num_children = 1, num_child_children = 1;
	pid_t pid;
	
	if(argc > 1)
		num_children = atoi(argv[1]);
	if(argc > 2)
		num_child_children = atoi(argv[2]);
		
	printf("parent pid=%d\n", getpid());
	
	for(i = 0; i < num_children; i++)
		switch((pid = fork())) {
			case -1:  /* error */
				printf("error: couldn't fork child %d\n", i);
				return 1;
				break;
				
			case 0:  /* child */
				printf("running child %d (pid=%d)\n", i, getpid());
				nice(39);	
				for(i = 0; i < num_child_children; i++)
					switch((pid = fork())) {
						case -1:  /* error */
							printf("error: couldn't fork child child %d\n", i);
							return 1;
							break;
							
						case 0:  /* child */
							printf("running child child %d (pid=%d)\n", i, \
									getpid());
							nice(39);	
							while(1)  /* loop */
								sleep(1);
							break;
							
						default:  /* parent */
							printf("forked child child %d (pid=%d)\n", i, \
									getpid());
							break;
					}
				while(1)  /* loop */
					sleep(1);
				break;
				
			default:  /* parent */
				printf("forked child %d (pid=%d)\n", i, getpid());
				break;
		}

	nice(39);	
	while(1)  /* loop */
		sleep(1);

	return 0;
}
