/* create child threads */
/* must be run as root */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <pthread.h>

void *handle_child(void *arg)
{
	unsigned int i, num_children = *((int *) arg), num_child_children = 0;
	pthread_t child;
	
	for(i = 0; i < num_children; i++) {
		if(pthread_create(&child, NULL, handle_child, &num_child_children)) {
			printf("error: couldn't fork child child %d\n", i);
			pthread_exit(NULL);
		}
		printf("forked child %d (pid=%d)\n", i, getpid());
	}	 

	nice(39);	
	while(1)  /* loop */
		sleep(1);
}
	
int main(int argc, char **argv)
{
	unsigned int i, num_children = 1, num_child_children = 1;
	pthread_t child;
		
	if(argc > 1)
		num_children = atoi(argv[1]);
	if(argc > 2)
		num_child_children = atoi(argv[2]);
		
	printf("parent pid=%d\n", getpid());
 	
	for(i = 0; i < num_children; i++) {
		if(pthread_create(&child, NULL, handle_child, &num_child_children)) {
			printf("error: couldn't fork child %d\n", i);
			return 1;
		}
		printf("forked child %d (pid=%d)\n", i, getpid());
	}	 

	nice(39);	
	while(1)  /* loop */
		sleep(1);

	return 0;
}
